/*
 * Copyright (C) 2015 David
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.ecom.quariument.ejb;

/**
 *
 * @author David
 */

import com.ecom.quariument.ejb.ApplicationStates;
import com.ecom.quariument.ejb.ApplicationStatus;
import com.ecom.quariument.ejb.QuariumNotification;
import com.ecom.quariument.ejb.ServiceData;
import java.util.Collection;
import java.util.Date;

//import com.vaadin.demo.dashboard.domain.DashboardNotification;

import com.ecom.quariument.ejb.User;
import com.vaadin.data.util.BeanItemContainer;
import java.util.ArrayList;

/**
 * QuickTickets Dashboard backend API.
 */
public interface DataProvider {
    
    /**
     * @param userName
     * @param password
     * @return Authenticated used.
     */
    User authenticate(String userName, String password);

    /**
     * @return The number of unread notifications for the current user.
     */
    int getUnreadNotificationsCount();

    /**
     * @return Notifications for the current user.
     */
    Collection<QuariumNotification> getNotifications();
    
    /**
     * @return Status of the server.
     */
    public BeanItemContainer<ApplicationStatus> getApplicationStatusData();
    
    /**
     * @return Application list of the server
     */
    public ArrayList<ApplicationStates> getApplicationData();
    
    /*
    *@return ServiceData.class including dashboard, cassandra, glassfish and proxy state
    */
    public ServiceData getServiceData();
    
    /*
    *@param BeanItemContainer<ApplicationStates>
    */
    public void setApplication(BeanItemContainer<ApplicationStates> container);
    
    /*
    *CassandraTest @return string
    */
    public String getCassandraTest();
    
   
}
