/*
 * Copyright (C) 2015 David
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.ecom.quariument.ejb;



//import com.ecom.quariumcl.ApplicationStates;
//import com.ecom.quariumcl.ApplicationStatus;
//import com.ecom.quariumcl.QuariumNotification;
//import com.ecom.quariumcl.ServiceData;
//import com.ecom.quariumcl.User;
import com.ecom.quariument.database.cassandra.CassandraMapping;
import com.google.common.base.Predicate;
import com.google.common.collect.Collections2;
//import com.vaadin.data.Item;
//import com.vaadin.data.util.BeanItem;
import com.vaadin.data.util.BeanItemContainer;
import com.vaadin.server.Page;
import com.vaadin.ui.Notification;
import com.vaadin.ui.OptionGroup;
import com.vaadin.ui.TextField;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;


/**
 *
 * @author David
 */
public class QuariumDataProvider implements DataProvider, Serializable {
    
    private final Collection<QuariumNotification> notifications = randomNotifications();
    
    @Override
    public User authenticate(String userName, String password) {
        //connection to server--sending data--geting info and loading to User
        User user = new User();
        if ("admin".equals(userName) && "admin".equals(password)) {
            user.setFirstName(userName);
            user.setLastName("Tester");
            user.setRole("admin");
            String email = user.getFirstName().toLowerCase() + "."
                    + user.getLastName().toLowerCase() + "@"
                    + "palacsintas" + ".com";
            user.setEmail(email.replaceAll(" ", ""));
            user.setLocation("Tester Room");
            user.setBio("Quarium Admin Tester");
            
        } else if ("tester".equals(userName) && "tester".equals(password)){
        user.setFirstName(userName);
        user.setLastName("Tester");
        user.setRole("user");
        String email = user.getFirstName().toLowerCase() + "."
                + user.getLastName().toLowerCase() + "@"
                + "palacsintas" + ".com";
        user.setEmail(email.replaceAll(" ", ""));
        user.setLocation("Tester Room");
        user.setBio("Quarium User Tester");
        } else {
            user = null;
        }
        
        return user;
    }
    
    @Override
    public Collection<QuariumNotification> getNotifications() {
        
        for (QuariumNotification notification : notifications) {
            notification.setRead(true);
        }
        return Collections.unmodifiableCollection(notifications);
    }
    
    @Override
    public int getUnreadNotificationsCount() {
        Predicate<QuariumNotification> unreadPredicate = new Predicate<QuariumNotification>() {
            @Override
            public boolean apply(QuariumNotification input) {
                return !input.isRead();
            }
        };
        return Collections2.filter(notifications, unreadPredicate).size();
    }
    
    @Override
    public BeanItemContainer<ApplicationStatus> getApplicationStatusData(){
        
        BeanItemContainer<ApplicationStatus> container = new BeanItemContainer<ApplicationStatus>(ApplicationStatus.class);
                
                //geting data from server now dummy data
                ApplicationStatus app1 = new ApplicationStatus("Test app1",true,(int)(Math.random()*100),(int)(Math.random()*100),(int)(Math.random()*100));
                ApplicationStatus app2 = new ApplicationStatus("Test app2",true,(int)(Math.random()*100),(int)(Math.random()*100),(int)(Math.random()*100));
                ApplicationStatus app3 = new ApplicationStatus("Test app3",true,(int)(Math.random()*100),(int)(Math.random()*100),(int)(Math.random()*100));
                
                container.addBean(app1);
                container.addBean(app2);
                container.addBean(app3);
                
                return container;
    }
    
    @Override
    public ServiceData getServiceData(){
        ServiceData sd = new ServiceData();
        //lekérdezni és beállítani
        return sd;
    }
    
//data
static Collection<QuariumNotification> randomNotifications() {
        QuariumNotification n1 = new QuariumNotification();
        n1.setId(1);
        n1.setFirstName("David");
        n1.setLastName("Woof");
        n1.setAction("created a new woof event");
        n1.setPrettyTime("25 minutes ago");
        n1.setContent("Please woof me");

        QuariumNotification n2 = new QuariumNotification();
        n2.setId(2);
        n2.setFirstName("Benedek");
        n2.setLastName("Owner");
        n2.setAction("schedule event");
        n2.setPrettyTime("2 minutes ago");
        n2.setContent("Woofing puppy");

        return Arrays.asList(n1, n2);
    }

    @Override
    public ArrayList<ApplicationStates> getApplicationData(){
        ArrayList<ApplicationStates> apps = new ArrayList<ApplicationStates>();
                
                 //test
                
                String name;
                
                name = ("TestApp");
                
                
                OptionGroup state = new OptionGroup();
                state.addItems("Enable","Disable","Reload");
                state.setItemCaption("Enable", "Enable");
                state.setItemCaption("Disable", "Disable");
                state.setItemCaption("Reload", "Reload");
                state.setImmediate(true);
                state.addStyleName("small");
                state.setMultiSelect(false);
                state.select("Enable"); //readed from object
               // state.setItemIcon("Option One", testIcon.get());
               // state.setItemIcon("Option Two", testIcon.get());
               // state.setItemIcon("Option Three", testIcon.get(true));
                OptionGroup action = new OptionGroup();
                action.addItems("Deploy","Undeploy","Redeploy");
                action.setItemCaption("Deploy", "Deploy");
                action.setItemCaption("Undeploy", "Undeploy");
                action.setItemCaption("Redeploy", "Redeploy");
                action.setImmediate(true);
                action.addStyleName("small");
                action.setMultiSelect(false);
                action.select("Undeploy");
                //readed from object, setting icons
               // state.setItemIcon("Option One", testIcon.get());
               // state.setItemIcon("Option Two", testIcon.get());
               // state.setItemIcon("Option Three", testIcon.get(true));
                TextField description = new TextField();
                description.setValue("Application to test the server");
                String name2 = new String("nextapp");
                TextField de = new TextField();
                de.setValue("new tests to await");
                
                ApplicationStates myapp = new ApplicationStates(name, state, action, description);
                ApplicationStates myapp2 = new ApplicationStates(name2, state, action, de);

//test end

                apps.add(myapp);
                apps.add(myapp2);
               
                try {
                    Notification.show("data"+apps.get(0).getName());    
                } catch (Exception e) {
                }

                return apps;
    }
    
    @Override
    public void setApplication(BeanItemContainer<ApplicationStates> container){
        Notification notif = new Notification("test");
        String description = null;
        for (Iterator i = container.getItemIds().iterator(); i.hasNext();){
            
            ApplicationStates item = (ApplicationStates) i.next();
                    int iid = container.getItemIds().indexOf(item);
            
            
            description =description+"<br>Container"+item.getName()+" Saved data "+getApplicationData().get(iid).getName();
            
        }
        notif.setDescription(description);
        notif.show(Page.getCurrent());
    }
    
    @Override
    public String getCassandraTest(){
        return CassandraMapping.init();
    }
}
