/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ecom.quariument.ejb;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;
import javax.validation.constraints.Size;



/**
 *
 * @author admin
 */
//@Entity
@Table(name = "users")
public class User implements Serializable {
    
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "id")
    private long id;
    
    /* This part causes validation error when field loses focus
    *  and the content is not valid.
    */
    
    @NotNull
    @Column(name ="role")
    private String role;
    
    @NotNull
    @Size(min =2, max = 20)
    @Column(name ="firstName")
    private String firstName;
    
    @NotNull
    @Size(min = 2, max = 20)
    @Column(name ="lastName")
    private String lastName;
    
    @Column(name ="title")
    private String title;
    @Column(name ="male")
    private boolean male;
    
    @NotNull
    @Pattern(regexp="[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\\."
        +"[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@"
        +"(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?",
             message="{invalid.email}")
    @Column(name ="email")
    private String email;
    
    @Column(name ="location")
    private String location;
    @Column(name ="phone")
    private String phone;
    @Column(name ="newsletterSubscription")
    private Integer newsletterSubscription;
    @Column(name ="website")
    private String website;
    @Column(name ="bio")
    private String bio;
    
    @NotNull
    @Column(name ="directory")
    private String directory;
    @NotNull
    @Column(name ="memorySize")
    private int memorySize;
    @NotNull
    @Column(name ="directorySize")
    private int directorySize;
    //@NotNull
    @Column(name ="dedicatedProcessor")
    private int dedicatedProcessor;

    public String getDirectory() {
        return directory;
    }

    public void setDirectory(String directory) {
        this.directory = directory;
    }

    public int getMemorySize() {
        return memorySize;
    }

    public void setMemorySize(int memorySize) {
        this.memorySize = memorySize;
    }

    public int getDirectorySize() {
        return directorySize;
    }

    public void setDirectorySize(int directorySize) {
        this.directorySize = directorySize;
    }

    public int getDedicatedProcessor() {
        return dedicatedProcessor;
    }

    public void setDedicatedProcessor(int dedicatedProcessor) {
        this.dedicatedProcessor = dedicatedProcessor;
    }
    
    

    public String getEmail() {
        return email;
    }

    public void setEmail(final String email) {
        this.email = email;
    }

    public String getLocation() {
        return location;
    }

    public void setLocation(final String location) {
        this.location = location;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(final String phone) {
        this.phone = phone;
    }

    public Integer getNewsletterSubscription() {
        return newsletterSubscription;
    }

    public void setNewsletterSubscription(final Integer newsletterSubscription) {
        this.newsletterSubscription = newsletterSubscription;
    }

    public String getWebsite() {
        return website;
    }

    public void setWebsite(final String website) {
        this.website = website;
    }

    public String getBio() {
        return bio;
    }

    public void setBio(final String bio) {
        this.bio = bio;
    }

    public boolean isMale() {
        return male;
    }

    public void setMale(final boolean male) {
        this.male = male;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(final String title) {
        this.title = title;
    }

    public String getRole() {
        return role;
    }

    public void setRole(final String role) {
        this.role = role;
    }

    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(final String firstName) {
        this.firstName = firstName;
    }

    public String getLastName() {
        return lastName;
    }

    public void setLastName(final String lastName) {
        this.lastName = lastName;
    }

}

