/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ecom.quariument.rest;

import javax.json.Json;
import javax.ws.rs.ClientErrorException;
import javax.ws.rs.client.Client;
import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.client.Invocation;
import javax.ws.rs.client.WebTarget;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.json.JsonObject;
import javax.json.JsonString;
import com.ecom.quariument.rest.Authenticator;

/**
 * Jersey REST client generated for REST resource:application-wadl?detail=true
 * [domain/host-port/]<br>
 * USAGE:
 * <pre>
        MonitorClient client = new MonitorClient();
        Object response = client.XXX(...);
        // do whatever with response
        client.close();
 </pre>
 *
 * @author oracle
 */
public class MonitorClient {
    private WebTarget webTarget;
    private Client client;
    private static final String BASE_URI = "http://localhost:4848/monitoring/";

    public MonitorClient() {
        client = javax.ws.rs.client.ClientBuilder.newClient().register(new Authenticator("admin","qwe123"));
        
        webTarget = client.target(BASE_URI).path("domain/host-port");
        
        
    }
    
    public String getResponse() {
        

        JsonObject response = webTarget.request(MediaType.APPLICATION_JSON).get(JsonObject.class);

        String output = response.getJsonObject("properties").getString("port");
        
        
        return output;
    }

    /**
     * @param responseType Class representing the response
     * @return response object (instance of responseType class)
     */
    public <T> T processGet(Class<T> responseType) throws ClientErrorException {
        return webTarget.request().get(responseType);
    }

    /**
     * @param responseType Class representing the response
     * @return response object (instance of responseType class)
     */
    public <T> T processGetLegacyFormat_JSON(Class<T> responseType) throws ClientErrorException {
        return webTarget.request(javax.ws.rs.core.MediaType.APPLICATION_JSON).get(responseType);
    }

    /**
     * @param responseType Class representing the response
     * @return response object (instance of responseType class)
     */
    public <T> T processGetLegacyFormat_XML(Class<T> responseType) throws ClientErrorException {
        return webTarget.request(javax.ws.rs.core.MediaType.APPLICATION_XML).get(responseType);
    }

    /**
     * @param responseType Class representing the response
     * @return response object (instance of responseType class)
     */
    public <T> T processGetLegacyFormat_FORM(Class<T> responseType) throws ClientErrorException {
        return webTarget.request(javax.ws.rs.core.MediaType.APPLICATION_FORM_URLENCODED).get(responseType);
    }

    /**
     * @param responseType Class representing the response
     * @return response object (instance of responseType class)
     */
    public <T> T processSseGet(Class<T> responseType) throws ClientErrorException {
        return webTarget.request().get(responseType);
    }

    public void close() {
        client.close();
    }
    
}
