/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ecom.quariument.component;

import com.vaadin.ui.Alignment;
import com.vaadin.ui.Button;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.ui.HorizontalLayout;
import com.vaadin.ui.Label;
import com.vaadin.ui.VerticalLayout;
import com.vaadin.ui.Window;
import com.vaadin.event.ShortcutAction.KeyCode;
/**
 *
 * @author David
 */
public class AllertWindow extends Window implements Button.ClickListener {
        final Callback callback;
        final Button okButton = new Button("Ok",this);
        final Button cancelButton = new Button("Cancel",this);
        
        
        
        public AllertWindow(String caption, String question, 
                String okLabel, String cancelLabel, Callback callback) {        
                        setCaption(caption);
                        this.callback = callback;
                        VerticalLayout mainContent = new VerticalLayout();
                        setContent(mainContent);
                        okButton.setCaption(okLabel);
                        cancelButton.setCaption(cancelLabel);
                        
                        okButton.focus();
                        setModal(true);
                        center();
                        mainContent.setSizeFull();
                        
                        
                        if (question != null) {
                                mainContent.addComponent(new Label(question));
                        }
                        final HorizontalLayout buttonLayout = new HorizontalLayout();
                        buttonLayout.setSpacing(true);
                        buttonLayout.addComponent(okButton);
                        buttonLayout.setComponentAlignment(okButton, Alignment.MIDDLE_RIGHT);
                        buttonLayout.addComponent(cancelButton);
                        buttonLayout.setComponentAlignment(cancelButton, Alignment.MIDDLE_RIGHT);
                        mainContent.addComponent(buttonLayout);
                        mainContent.setMargin(true);
                        buttonLayout.setMargin(true);
                        buttonLayout.setWidth("100%");
                        setCloseShortcut(KeyCode.ESCAPE, null);
                        setWidth("300px");
                        setHeight("200px");
                        

        }
        @Override
        public void buttonClick(final ClickEvent event) {
                callback.response(event.getButton() == okButton);
                close();
        }
                        
        public interface Callback {
                void response(boolean ok);
        }
}
