/*
 * Copyright (C) 2015 David
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package com.ecom.quariument.view;

/**
 *
 * @author David
 */

import com.ecom.quariument.view.admin.AdminView;
import com.ecom.quariument.view.initial.InitialView;
import com.ecom.quariument.view.myapplications.MyApplicationsView;
import com.vaadin.navigator.View;
import com.vaadin.server.FontAwesome;
import com.vaadin.server.Resource;

public enum QuariumViewType {
    INITIAL("initial", InitialView.class, FontAwesome.HOME, false,true), MYAPPS(
            "myapps", MyApplicationsView.class, FontAwesome.BAR_CHART_O, false,true),
    ADMIN("admin",AdminView.class, FontAwesome.GEARS, false, false);

    private final String viewName;
    private final Class<? extends View> viewClass;
    private final Resource icon;
    private final boolean stateful;
    private final boolean userSees;

    private QuariumViewType(final String viewName,
            final Class<? extends View> viewClass, final Resource icon,
            final boolean stateful, final boolean userSees) {
        this.viewName = viewName;
        this.viewClass = viewClass;
        this.icon = icon;
        this.stateful = stateful;
        this.userSees = userSees;
    }

    public boolean isStateful() {
        return stateful;
    }
    
    public boolean isUserSees(){
        return userSees;
    }

    public String getViewName() {
        return viewName;
    }

    public Class<? extends View> getViewClass() {
        return viewClass;
    }

    public Resource getIcon() {
        return icon;
    }

    public static QuariumViewType getByViewName(final String viewName) {
        QuariumViewType result = null;
        for (QuariumViewType viewType : values()) {
            if (viewType.getViewName().equals(viewName)) {
                result = viewType;
                break;
            }
        }
        return result;
    }

}
