/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ecom.quariument.view.myapplications;

import com.ecom.quariument.component.AllertWindow;
import com.ecom.quariument.ejb.ApplicationStates;
import com.ecom.quariument.ui.MyUI;
import com.vaadin.event.ShortcutAction;
import com.vaadin.ui.TextArea;
import com.vaadin.ui.CheckBox;
import com.vaadin.ui.VerticalLayout;
import com.vaadin.ui.HorizontalLayout;
import com.vaadin.ui.Button;
import com.vaadin.ui.Button.ClickListener;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.navigator.View;
import com.vaadin.ui.Label;
import com.vaadin.ui.Panel;
import com.vaadin.ui.Upload;
import com.vaadin.ui.Table;
import com.vaadin.ui.Window;
import com.vaadin.data.Container;
import com.vaadin.data.util.BeanItemContainer;
//import com.vaadin.ui.Notification;
//import com.vaadin.ui.OptionGroup;
//import com.vaadin.ui.TextField;
//import com.vaadin.data.Property.ValueChangeListener;
//import com.vaadin.data.Property.ValueChangeEvent;
//import com.vaadin.data.Property;
import com.vaadin.navigator.ViewChangeListener;
import com.vaadin.ui.Alignment;
import com.vaadin.ui.Notification;
import com.vaadin.ui.OptionGroup;
import com.vaadin.ui.TextField;
import java.util.ArrayList;
import java.util.List;
//import com.vaadin.server.Page;
//import com.vaadin.shared.Position;
/**
 *
 * @author David
 */
public class MyApplicationsView extends VerticalLayout implements View{
        BeanItemContainer<ApplicationStates> container = new BeanItemContainer<ApplicationStates>(ApplicationStates.class);
        
        public MyApplicationsView(){
                setMargin(true);
                addStyleName("content-myapplications");
                
                Label h1 = new Label("Applications");
                h1.addStyleName("h1");
                addComponent(h1);
                
                VerticalLayout row = new VerticalLayout();
                row.setWidth("100%");
                row.setSpacing(true);
                addComponent(row);
                
                row.addComponent(deployNewApplication());
                row.addComponent(listOfMyApplications());
        }
        
        Panel deployNewApplication(){
                        
                Panel p = new Panel("Add new application");

                VerticalLayout pcontent = new VerticalLayout();
                pcontent.setSpacing(true);
                pcontent.setMargin(true);
                p.setSizeUndefined();
                p.setContent(pcontent);
                
                MyUploader upload = new MyUploader(new MyUploader.Callback() {

                        @Override
                        public void response(String filename) {
                        Notification.show("Implementció",
                                "Hogyan hozzon létre új objektumot?", Notification.Type.ERROR_MESSAGE);
                        }
                });
                pcontent.addComponent(upload);
                return p;
        }
        
        
        Panel listOfMyApplications(){
                Panel p = new Panel("List of Applications");
               
                VerticalLayout pcontent = new VerticalLayout();
                pcontent.setSpacing(true);
                pcontent.setMargin(true);
                p.setContent(pcontent);
               
                //adding the data to a container
                
                ArrayList<ApplicationStates> apps;
                apps =  MyUI.getDataProvider().getApplicationData();
                
                for (int i=0;i<apps.size();i++) {
                        container.addBean(apps.get(i));
                        
                }

                Table table = new Table();
                table.setContainerDataSource(container);
                table.setPageLength(table.size());
                //table.setImmediate(true);
                //table.setEditable(true);
                
                
                //itt lenne  abetöltő ciklus vége
                pcontent.addComponent(table); 
                
                HorizontalLayout buttonLayout = new HorizontalLayout();
                
                pcontent.addComponent(buttonLayout);
                
                Button ok = new Button("Run changes");
                ok.addClickListener(new ClickListener() {
                        @Override
                        public void buttonClick(final ClickEvent event) {
                                
                                AllertWindow win = new AllertWindow("Warning",
                                "Changes will be applied! Some changes take place only after rebooting the container!",
                                "Apply","Cancel",new AllertWindow.Callback() {
                                        @Override
                                        public void response(boolean isOk) {
                                                if (isOk) {
                                                        MyUI.getDataProvider().setApplication(container);
                                                        
                                                } else {
                                                        Notification.show("Response cancel");
                                                }

                                        }
                                });
                                getUI().addWindow(win);
                                win.center();
                                win.focus();
                            }
                        });
                buttonLayout.addComponent(ok);
                buttonLayout.setComponentAlignment(ok, Alignment.MIDDLE_LEFT);
                Button reset = new Button("Reset changes");
                reset.addClickListener(new ClickListener() {
                        @Override
                        public void buttonClick(final ClickEvent event) {
                                
                                AllertWindow win = new AllertWindow("Warning",
                                "Changes will be reseted!",
                                "Apply","Cancel",new AllertWindow.Callback() {
                                        @Override
                                        public void response(boolean isOk) {
                                                if (isOk) {
                                                        ArrayList<ApplicationStates> reapps;
                                                        reapps = MyUI.getDataProvider().getApplicationData();
                                                        container.removeAllItems();
                                                        container.addAll(reapps);
                                                        Notification.show("reloaded");
                                                } else {
                                                        Notification.show("Response reset");
                                                }

                                        }
                                });
                                getUI().addWindow(win);
                                win.center();
                                win.focus();
                            }
                        });
                buttonLayout.addComponent(reset);
                buttonLayout.setComponentAlignment(reset, Alignment.MIDDLE_LEFT);
        return p;       
        } 
        @Override
    public void enter(final ViewChangeListener.ViewChangeEvent event) {
        // TODO Auto-generated method stub

    }
        
}
