/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ecom.quariument.view.myapplications;

import com.vaadin.ui.Alignment;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import com.vaadin.ui.Upload;
import com.vaadin.ui.Panel;
import com.vaadin.ui.CustomComponent;
import com.vaadin.ui.VerticalLayout;
import com.vaadin.ui.HorizontalLayout;
import com.vaadin.ui.Notification;
import com.vaadin.ui.Upload.Receiver;
import com.vaadin.ui.Upload.StartedListener;
import com.vaadin.ui.Upload.ProgressListener;
import com.vaadin.ui.Upload.FinishedListener;
import com.vaadin.ui.Upload.SucceededListener;
import com.vaadin.ui.Upload.FailedListener;
import com.vaadin.ui.Upload.StartedEvent;
import com.vaadin.ui.Upload.FinishedEvent;
import com.vaadin.ui.Label;
import com.vaadin.ui.ProgressBar;
import com.vaadin.ui.Button;
import com.vaadin.ui.Button.ClickListener;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.ui.Window;
import com.vaadin.ui.FormLayout;
import com.vaadin.ui.Upload.FailedEvent;
import com.vaadin.ui.Upload.SucceededEvent;
import com.vaadin.ui.Upload.ChangeEvent;
import com.vaadin.ui.Upload.ChangeListener;
import com.vaadin.ui.Panel;

public class MyUploader extends CustomComponent
                        implements SucceededListener,
                                   FailedListener,
                                   Receiver,
                                   ChangeListener
                                   //StartedListener,
                                   //ProgressListener,
                                   //FinishedListener
                                   
{

    HorizontalLayout root;         // Root element for contained components.
    File  file;         // File to write to.
    UploadInfoWindow uploadInfoWindow;
    Callback callback;
    public MyUploader(Callback callback) {
            this.callback = callback;
        root = new HorizontalLayout();
        setCompositionRoot(root);

        // Create the Upload component.
        final Upload upload =
                new Upload("Upload a WAR file", this);

        // Use a custom button caption instead of plain "Upload".
        upload.setButtonCaption("Upload");

        // Listen for events regarding the success of upload.
        upload.addListener((Upload.SucceededListener) this);
        upload.addListener((Upload.FailedListener) this);
        upload.addChangeListener(this);
        uploadInfoWindow = new UploadInfoWindow(upload);
        uploadInfoWindow.setVisible(false);
        root.addComponent(upload);
        root.addComponent(uploadInfoWindow);
        upload.addStartedListener(new StartedListener() {
                @Override
                public void uploadStarted(final StartedEvent event) {
                        uploadInfoWindow.setVisible(true);
                        /*if (uploadInfoWindow.getParent() == null) {
                                
                                getUI().getCurrent().addWindow(uploadInfoWindow);
                        }		uploadInfoWindow.setClosable(false);*/
                }
        });
        upload.addFinishedListener(new Upload.FinishedListener() {
                @Override
                public void uploadFinished(final FinishedEvent event) {
                        uploadInfoWindow.setVisible(false);
                }
        });

        
        

        
    }

    // Callback method to begin receiving the upload.
    private static class UploadInfoWindow extends VerticalLayout implements	    
            StartedListener, 
            ProgressListener,	    
            FailedListener, 
            SucceededListener,	    
            FinishedListener {
            private final Label state = new Label();		
            private final Label fileName = new Label();	
            private final Label textualProgress = new Label(); 	
            private final ProgressBar progressBar = new ProgressBar();	
            private final Button cancelButton;	
            public UploadInfoWindow(final Upload upload) {
                    //super("Status");
                    setWidth(350, Unit.PIXELS); 	    
                    addStyleName("upload-info");                
                    //setResizable(false);	    
                    //setDraggable(false); 	    
                    final FormLayout l = new FormLayout();	    
                    addComponent(l);	    
                    l.setMargin(true); 	    
                    final HorizontalLayout stateLayout = new HorizontalLayout();	    
                    stateLayout.setSpacing(true);	    
                    stateLayout.addComponent(state); 	    
                    cancelButton = new Button("Cancel");	    
                    cancelButton.addClickListener(new ClickListener() {		
                            @Override		
                            public void buttonClick(final ClickEvent event) {		    
                                    upload.interruptUpload();
                                }		
                        });	    
             cancelButton.setVisible(false);	    
             cancelButton.setStyleName("small");	    
             stateLayout.addComponent(cancelButton); 	    
             stateLayout.setCaption("Current state");	    
             state.setValue("Idle");	    
             l.addComponent(stateLayout); 	    
             fileName.setCaption("File name");	    
             l.addComponent(fileName); 	     	    
             progressBar.setCaption("Progress");	    
             progressBar.setVisible(false);	    
             l.addComponent(progressBar); 	    
             textualProgress.setVisible(false);	    
             l.addComponent(textualProgress); 	    
             upload.addStartedListener(this);	    
             upload.addProgressListener(this);	    
             upload.addFailedListener(this);	    
             upload.addSucceededListener(this);	    
             upload.addFinishedListener(this); 	
            } 	
            @Override	public void uploadFinished(final FinishedEvent event) {	    
                    state.setValue("Finished");	    
                progressBar.setVisible(false);	    
                textualProgress.setVisible(false);	    
                cancelButton.setVisible(false);	
                } 	
            @Override	
            public void uploadStarted(final StartedEvent event) {	    
                // this method gets called immediately after upload is started	    
                    progressBar.setValue(0f);	    
                    progressBar.setVisible(true);	    
                    getUI().getCurrent().setPollInterval(500);	    
                    textualProgress.setVisible(true);	    
                // updates to client	    
                    state.setValue("Uploading");	    
                    fileName.setValue(event.getFilename()); 	    
                    cancelButton.setVisible(true);	
                } 	
            @Override	
            public void updateProgress(final long readBytes,final long contentLength) {	    
                // this method gets called several times during the update	    
                    progressBar.setValue(new Float(readBytes / (float) contentLength));	    
                    textualProgress.setValue("Processed " + readBytes + " bytes of "		    
                            + contentLength);	    	
                } 	
            @Override	
            public void uploadSucceeded(final SucceededEvent event) {	 
                    Notification.show("File "+event.getFilename()+
                            "uploaded!", Notification.Type.TRAY_NOTIFICATION);
                   	
                } 	
            @Override	public void uploadFailed(final FailedEvent event) {	    
                    
                }    
    }
    @Override
    public void filenameChanged(ChangeEvent event) {

            if (getExtension(event.getFilename()).toUpperCase().equals("WAR")) {
                    Notification.show("The WAR file:\n"+event.getFilename()
                            +"\n is selected.", Notification.Type.HUMANIZED_MESSAGE);
            } else {
                   Notification.show("Warning","\nThe extension of the selected file:\n"+event.getFilename()
                            +" is not WAR.\n"
                           + "Only war files can be deployed!\n"
                           + "You can continue if you are sure\n"
                           + "that it can be deployed.", Notification.Type.ERROR_MESSAGE); 
            }
    }
    @Override
    public OutputStream receiveUpload(String filename,
                                      String MIMEType) {
        FileOutputStream fos = null; // Output stream to write to
        file = new File("c:/uploads/" + filename);
        try {
                Notification.show("Starting up", Notification.Type.TRAY_NOTIFICATION);
            // Open the file for writing.
            fos = new FileOutputStream(file);
        } catch (final java.io.FileNotFoundException e) {
            // Error while opening the file. Not reported here.
            e.printStackTrace();
            Notification.show("Upload failed"+e.getMessage(), Notification.Type.ERROR_MESSAGE);
            return null;
        }

        return fos; // Return the output stream to write to
    }

    // This is called if the upload is finished.
    @Override
    public void uploadSucceeded(Upload.SucceededEvent event) {
        // Log the upload on screen.
        Label label = new Label("File " + event.getFilename()
                + " of type '" + event.getMIMEType()
                + "' uploaded.");
        label.addStyleName("h2");
        VerticalLayout container = new VerticalLayout();
        container.addComponent(label);
        container.setSizeFull();
        container.setMargin(true);
        container.setComponentAlignment(label, Alignment.MIDDLE_CENTER);
        root.addComponent(container);
        callback.response(event.getFilename());
        
        
    }

    // This is called if the upload fails.
    @Override
    public void uploadFailed(Upload.FailedEvent event) {
        // Log the failure on screen.
            Label label = new Label("Uploading of "
                + event.getFilename() + " failed.");
        label.addStyleName("h2");
        VerticalLayout container = new VerticalLayout();
        container.addComponent(label);
        container.setSizeFull();
         container.setMargin(true);
        container.setComponentAlignment(label, Alignment.MIDDLE_CENTER);
        root.addComponent(container);
       
    }
    public static String getExtension(String fileName) {

        // Checks for nulls
        if (fileName == null) {
            throw new NullPointerException("Filename can not be null");
        }

        // Calculates the extension of the file
        int dotIndex = fileName.indexOf(".");
        while (dotIndex >= 0 && fileName.indexOf(".", dotIndex + 1) >= 0) {
            dotIndex = fileName.indexOf(".", dotIndex + 1);
        }
        dotIndex++;

        if (fileName.length() > dotIndex) {
            String ext = fileName.substring(dotIndex);

            // Ignore any query parameters
            int queryStringStart = ext.indexOf('?');
            if (queryStringStart > 0) {
                ext = ext.substring(0, queryStringStart);
            }

            
                return ext;
            
        }

        return "";
    }
    public interface Callback {
                void response(String filename);
        }
}